# Gridap.jl

Documentation of the Gridap library.

## Introduction

Gridap provides a set of tools for the grid-based approximation of
partial differential equations (PDEs) written in the
[Julia programming language](https://julialang.org/).
The goal is to provide a user friendly interface to a
rich set of discretization techniques such as
conforming and discontinuous Galerkin methods,
embedded domain techniques, and adaptive mesh refinement.

## How to use this documentation

* The first step for new users is to visit the [Getting Started](@ref) page.

* A detailed description of the software components is available in the [Manual](@ref) page.

* The API reference is found in the [API](@ref) page.

* Guidelines for developers of the Gridap project is found in the [Developer's Guide](@ref) page.

## Tutorials

In addition to these documentation pages, a set of tutorials written in jupyter notebooks will be available.

## Julia educational resources

A basic knowledge of the Julia programming language is needed to use the Gridap package.
Here, a list of resources to get started with this programming language.

* Official webpage [docs.julialang.org](https://docs.julialang.org/)
* Official list of learning resources [julialang.org/learning](https://julialang.org/learning/)



